# -*- coding:utf-8 -*-
"""
# PyStnWeather - a modification of "PyStationWeather"
# SYMBIAN_UID = 0xee1c3936
# Ver '0.3.4a'
# masa
# (c) 2009-2014 masa
# web = "http://masaland.cocolog-nifty.com/"
#
#Original program(PyStationWeather) was written by Hiisi. 
#Please see below  about original license.

This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""
#----original license---------------------------------------
# PyStationWeather
# SYMBIAN_UID = 0xE8496B43
# SIS_VERSION = '0.3.0'
# Copyright (c) 2008-2012 Hiisi (hiisi.proxy@gmail.com)

"""
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""

Debug_in  = 0 #*1
Debug_out = 0 #*1
# Debug output file
#   E:/Data/Weathertest0.htm
#   E:/Data/Weathertest2.txt
#   E:/Data/Weatherparse.txt

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import e32
import appuifw
import os
import os.path
import re
import socket
import urllib
try:
    import ConfigParser
except:
    appuifw.note(unicode('ConfigParserモジュールが見つかりません。'), 'error')
    raise
try:
    import appswitch
    appswitch.switch_to_bg(u'PyStnWeather')
except ImportError:
    pass
try:
    import waplib
    ISWAPLIB = 1
except ImportError:
    ISWAPLIB = 0
try:
    import japanese
    try:
        japanese.aliases.encodings.aliases.aliases['sjis'] = \
         'japanese.shift_jis_docomo'
        '\xf8\x9f'.decode('sjis')
        
    except:
        raise ImportError
except ImportError:
    appuifw.note(u'JapaneseCodecs+emojiが見つかりません。', 'error', 1)
    raise

__scriptname__ = 'PyStationWeather'
__version__ = '0.3.0'
__author__ = 'Hiisi (hiisi.proxy@gmail.com)'
__copyright__ = 'Copyright 2008-2012 Hiisi (hiisi.proxy@gmail.com)'

# データフォルダ
DATA_PATH = u'E:\\Data\\Hiisi\\PyStation'
if not os.path.isdir(DATA_PATH):
    DATA_PATH = u'C:\\Data\\Hiisi\\PyStation'
    if not os.path.isdir(DATA_PATH):
        appuifw.note(unicode('設定ファイルが見つかりません。'), 'error', 1)
        raise

# 設定ファイル
CFG_FILE = os.path.join(DATA_PATH, u'PyStation.cfg')
if not os.path.isfile(CFG_FILE):
    appuifw.note(unicode('設定ファイルが見つかりません。'), 'error', 1)
    raise
APID = 0
SETTING = {}

# 出力HTMLファイル（E:ドライブを優先）
OUT_FILE = os.path.join(DATA_PATH, u'%s.html' % __scriptname__)
if os.path.exists(OUT_FILE):
    try:
        f = open(OUT_FILE, 'w')
        f.write(unicode('<?xml version="1.0"?>\r\n'))
        f.write(unicode('<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.1//EN" '))
        f.write(unicode('"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\r\n'))
        f.write(unicode('<html xmlns="http://www.w3.org/1999/xhtml" '))
        f.write(unicode('xml:lang="ja">\r\n'))
        f.write(unicode('<head>\r\n'))
        f.write(unicode('<meta http-equiv="Content-Type" '))
        f.write(unicode('content="text/html; charset=UTF-8" />\r\n'))
        f.write(unicode('<title>PyStation News</title>\r\n'))
        f.write(unicode('</head>\r\n'))
        f.write(unicode('<body>\r\n'))
        f.write(unicode('<h1>天気予報</h1>\r\n'))
        f.write(unicode('<p>接続エラー！もう一度接続してください。</p>\r\n'))
        f.write(unicode('<p>通信環境、設定、接続先サイトの仕様変更などについてチェックして下さい。</p>\r\n'))
        f.write(unicode('<hr />\r\n'))
        f.write(unicode('<p><a href="./PyStation.html">戻る</a></p>\r\n'))
        f.write(unicode('</body>\r\n'))
        f.write(unicode('</html>'))
        f.close()
    except IOError:
        pass

# 天気予報サービス（天気予報コムモバイル）
WEATHER_URL = 'http://m.tenki-yoho.com/city.php'    # DO NOT EDIT!!

class Fetcher:
    """天気予報を取得し、カレンダーに保存するクラス"""
    def __init__(self):
        """初期設定"""
        ap = socket.access_point(APID)
        socket.set_default_access_point(ap)
        if ISWAPLIB:
            if APID == waplib.APID_WAP:
                waplib.wap_connection({'Accept-Charset': 'Shift_JIS'})

        self.dayurl = '%s?city=%s' \
                       % (WEATHER_URL, str(SETTING['LOCID']))
        self.release_date = '' #weather forcast publication month/date/time

    def fetch(self):
        """メインの関数"""
        forecast = []
        daydata = self.fetch_data(self.dayurl)
        if daydata:
            forecast = self.parse_data(daydata)
            self.export_html(forecast)

            vcal = self.format_vcal(forecast)
            self.import_vcal(vcal)
    
    def fetch_data(self, dayurl):
        """天気予報サービスに接続し、データを取得"""
        try:
            if not Debug_in: #*1
                f = urllib.urlopen(dayurl)
                daydata = f.read()
                f.close()
            else:
                F = open('E:\\Data\\Weathertest0.htm')
                daydata = F.read()
                F.close()

            if Debug_out and not Debug_in: #*1
                F = open('E:\\Data\\Weathertest0.htm', 'w')
                F.write(daydata)
                F.close()

            daydata = daydata.decode('sjis')
            return daydata
        except:
#            raise
            return None
    

    def parse_data(self, Data):
        """データをパースし、天気予報データを辞書リストに格納"""

        datawk = re.sub(u"[\n\u2029 ]", "", Data)    #*1 delete LF and space
        #'地名'取得
        wk = re.findall(unicode('>〜([^a-z0-9<>]+)の天気予報'), datawk)
            #  参考　'〜' は　u'\u301c'、'〜'などは、エディタのUTF-8で
            #　読み込んだテキストデータからコピペすること
        self.city_area = (wk[0])    # findall 出力はリスト

        """日付の位置を探して、一日毎のデータに切り出す"""
        f1 = u'\d+/\d+\(.+?\)' #それぞれの日付
        f2 = unicode('データの見方')   #最後（次の項目)

        pattern1 = re.compile(f1, re.I)
        pattern2 = re.compile(f2, re.I)

        start_list = []
        find_list = pattern1.finditer(datawk, 0)  #find all
        for x in find_list: #call iter. and get result one by one
            r_p = x.start()                       #position
            start_list.append(r_p)

        find_list = pattern2.search(datawk, 0)
        r_p = find_list.start()
        start_list.append(r_p)
        start_list.sort()

        data_list = []
        if len(start_list) > 1:
            for n in range(1, len(start_list)):
                data_list.append(datawk[start_list[n-1]:start_list[n]])

        #発表日時の取りだし  注：天気予報コムモバイルには発表日時はない
        datawk = data_list[0] 
        #wk1 = re.findall(unicode('(\d+)/(\d+)'), datawk) 
          #return of findall is "list of tupple"
        #wk2 = re.findall(unicode('(\d+)時発表'), datawk) 
          #return of findall is "list"
        #self.release_date = (int(wk1[0][0]), int(wk1[0][1]), int(wk2[0])) 
        self.release_date = (0,0,0) #ダミーデータ

        """切り出し終わり"""

        year, month, day, hour, minute, sec = self.get_time()
        forecast = []
        LOG = ''
        dlist_log = [u'[dlist]']
        wlist_log = [u'\n[wlist]']
        tlist_log = [u'\n[tlist]']
        p_log     = [u'\n[p    ]']
        plist_log = [u'\n[plist]']
        slist_log = [u'\n[slist]']

        day_cnt = 0 #今日と明日のデータの切り分けフラグ

        for data in data_list: #日付毎のデータ処理
            # 日付データ（日付毎に切り出したデータなので、日付、天気はひとつ）
            ylist = []
            mlist = re.findall(unicode('(\d+)/\d+\(.+?\)'), data) 
            slist = re.findall(unicode('\d+/\d+\((.+?)\)'), data) #*
            d = re.findall(unicode('\d+/(\d+)\(.+?\)'), data)
            if int(mlist[0]) < month:
                ylist.append(str(year + 1))
            else:
                ylist.append(str(year))
            dlist = []
            dlist.append(u'%04d%02d%02d' \
                      % (int(ylist[0]) , int(mlist[0]), int(d[0])))
        
            # 天気データ
            wlist = re.findall(unicode('<img.+mini/([a-z][_a-z]+?)\.gif.+?>'), data)

            subtable = [
                (u'snow' , unicode('雪')),
                (u'cloud', unicode('曇')),
                (u'sun'  , unicode('晴')),
                (u'rain' , unicode('雨')),
                (u'storm' , unicode('暴風雨')),
                (u'blizzard' , unicode('吹雪')),
                (u'thunder' , unicode('雷')),
                (u'after', u'>'),
                (u'or', u'/'),
                (u'[a-z]+', unicode('〓')),
                (u'_', u'') ]
            for s in subtable:
                wlist[0] = re.sub(s[0], s[1], wlist[0])
                LOG = LOG + wlist[0] + '\n\n'

            # 気温データ
            t = re.findall(unicode('(-?\d+)℃'), data)
            tlist = []
            if len(t) >= 2:
                tlist.append(u'%s/%s' % (t[0], t[1]))
            elif len(t) == 1:
                tlist.append(u'%s/-' % t[0])
            else:
                tlist.append(u'-/-')

            # 降水確率データ
            data = re.sub(u">\d+%<", "", data) # 一日の降水確率データを削除
            p = re.findall(unicode('(\d+)%'), data) 
            plist = []
            if day_cnt == 0: #今日のデータ
                if len(p) >= 4:
                    plist.append(u'%s/%s/%s/%s' % (p[0], p[1], p[2], p[3])) 
                elif len(p) == 3:
                    plist.append(u'-/%s/%s/%s' % (p[0], p[1], p[2])) 
                elif len(p) == 2:
                    plist.append(u'-/-/%s/%s' % (p[0], p[1]))
                elif len(p) == 1:
                    plist.append(u'-/-/-/%s' % (p[0]))
                else:
                    plist.append(u'-/-/-/-')

            else: #明日のデータ
                if len(p) >= 4:
                    plist.append(u'%s/%s/%s/%s' % (p[0], p[1], p[2], p[3])) 
                elif len(p) == 3:
                    plist.append(u'%s/%s/%s/-' % (p[0], p[1], p[2])) 
                elif len(p) == 2:
                    plist.append(u'%s/%s/-/-' % (p[0], p[1]))
                elif len(p) == 1:
                    plist.append(u'%s/-/-/-' % (p[0]))
                else:
                    plist.append(u'-/-/-/-')

            if Debug_out: #*1
                dlist_log = dlist_log + dlist
                wlist_log = wlist_log + wlist
                tlist_log = tlist_log + tlist
                p_log     = p_log     + p
                plist_log = plist_log + plist
                slist_log = slist_log + slist

            forecast.append({'d': dlist[0], 'w': wlist[0], 't': tlist[0],
                             'p': plist[0], 's': slist[0]})
            day_cnt = 1

        if Debug_out: #*1
            F = open('E:\\Data\\Weathertest2.txt', 'w')
            F.write(LOG)
            F.close()

            F = open('E:\\Data\\Weatherparse.txt', 'w')
            for x in dlist_log: F.write(x + ',')
            for x in wlist_log: F.write(x + ',')
            for x in tlist_log: F.write(x + ',')
            for x in p_log:     F.write(x + ',')
            for x in plist_log: F.write(x + ',')
            for x in slist_log: F.write(x + ',')
            F.write('\n\n')
            F.close()

        return forecast
    
    def export_html(self, forecast):
        """天気予報を外部HTMLファイルに書き出し"""
        year, month, day, hour, minute, sec = self.get_time()
        try:
            f = open(OUT_FILE, 'w')
            
            f.write(unicode('<?xml version="1.0"?>\r\n'))
            f.write(unicode('<!DOCTYPE HTML PUBLIC '))
            f.write(unicode('"-//W3C//DTD XHTML 1.1//EN" '))
            f.write(unicode('"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'))
            f.write(unicode('\r\n'))
            f.write(unicode('<html xmlns="http://www.w3.org/1999/xhtml" '))
            f.write(unicode('xml:lang="ja">\r\n'))
            f.write(unicode('<head>\r\n'))
            f.write(unicode('<meta http-equiv="Content-Type" '))
            f.write(unicode('content="text/html; charset=UTF-8" />\r\n'))
            f.write(unicode('<title>PyStation Weather</title>\r\n'))
            f.write(unicode('</head>\r\n'))
            f.write(unicode('<body bgcolor="#e8e2fe">\r\n'))
            f.write(unicode('<h3>%sの天気予報</h3>\r\n' % self.city_area))    #*
#            f.write(unicode('　【%d月%d日 %d時発表】'  % self.release_date))  #*
            f.write(unicode('<ul>\r\n')) 
            for fc in forecast:
                w = fc['w']
                # 絵文字利用
                if SETTING['PICT'] == 1:
                    subtable = [(u'>', u'&gt;'),
                        (unicode('雪'), u'&#xe048;'),
                        (unicode('曇'), u'&#xe049;'),
                        (unicode('晴'), u'&#xe04a;'),
                        (unicode('雨'), u'&#xe04b;'),
                        (unicode('雷'), u'&#xe13d;'),
                        (unicode('暴風'), u'&#xe330;'),
                        (unicode('吹'), u'&#xe330;')]
                # img画像利用
                elif SETTING['PICT'] == 3 or SETTING['PICT'] == 4:
                    subtable = [(u'>', u'&gt;'),
                      (unicode('雪'), unicode('<img src="./icon/snow.jpg" alt="雪">')),
                      (unicode('曇'), unicode('<img src="./icon/cloud.jpg" alt="曇">')),
                      (unicode('晴'), unicode('<img src="./icon/sun.jpg" alt="晴">')),
                      (unicode('雨'), unicode('<img src="./icon/rain.jpg" alt="雨">')),
                      (unicode('雷'), unicode('<img src="./icon/thunder.jpg" alt="雷">')),
                      (unicode('暴風'), unicode('<img src="./icon/storm.jpg" alt="暴風">')),
                      (unicode('吹'), unicode('<img src="./icon/storm.jpg" alt="吹">'))]
                # 文字表示
                else: #PICT = 0,2
                    subtable = [(u'>', u'&gt;')]
                for s in subtable:
                    w = w.replace(s[0], s[1])
                f.write(unicode('<li>%d日（%s） %s<br />\r\n' \
#                  % (int(fc['d'][6:]), str(self.Zeller_wday(fc['d'])), str(w))))
                  % (int(fc['d'][6:]), str(fc['s']), str(w)))) #*
                f.write(unicode('気温：' + fc['t'] + '℃<br />\r\n'))
                f.write(unicode('降水確率：' + fc['p'] + '%</li>\r\n'))
            f.write(unicode('</ul>\r\n'))
            f.write(unicode('<hr />\r\n'))
#            f.write(unicode('<p>'))
            f.write(unicode('<a href="./PyStation.html">戻る</a><br />\r\n'))
            f.write(unicode('<a href="http://m.tenki-yoho.com/">'))
            f.write(unicode('天気予報コム モバイル</a>'))
#            f.write(unicode('</p>\r\n'))
#            f.write(unicode('<hr />\r\n'))
            f.write(unicode('<p>更新時刻：%d月%d日　%d:%02d</p>\r\n' \
                             % (month, day, hour, minute)))
            f.write(unicode('</body>\r\n'))
            f.write(unicode('</html>'))
            f.close()
        except IOError:
            pass
        except:
            f.close()
            pass
    
    def Zeller_wday(self, day):
        """Zellerの公式で曜日を求める"""
        year = int(day[:4])
        month = int(day[4:6])
        day = int(day[6:])
        if month in [1, 2]:
            year -= 1
            month += 12
        wday = [unicode('日'), unicode('月'), unicode('火'), \
                unicode('水'), unicode('木'), unicode('金'), \
                unicode('土')]
        w = int((year + year/4 - year/100 + year/400 + \
                 (((13 * month) + 8)/5) + day) % 7)
        return wday[w]
    
    def format_vcal(self, forecast):
        """辞書リストをvCal形式に変換"""
        year, month, day, hour, minute, sec = self.get_time()
        vcal = 'BEGIN:VCALENDAR\r\n'
        vcal += 'VERSION:1.0\r\n'
        for i in range(len(forecast)):
            vcal += 'BEGIN:VEVENT\r\n'
            if i < 2:
                vcal += 'DTSTART:'+ str(forecast[0]['d']) + 'T000000\r\n'
            else:
                vcal += 'DTSTART:'+ str(forecast[i]['d']) + 'T000000\r\n'
            vcal += 'DTEND:' + self.tomorrow(forecast[i]['d']) + 'T000000\r\n'
            vcal += 'SUMMARY;ENCODING=QUOTED-PRINTABLE;CHARSET=UTF-8:%s\r\n' \
                     % self.quopri(forecast[i], i)
            vcal += 'UID:' + __scriptname__ + '/' + str(i) +'\r\n'
            vcal += 'LAST-MODIFIED:%4d%02d%02dT%02d%02d%02d\r\n' \
                     % (year, month, day, hour, minute, (sec + i))
            vcal += 'TZ:+09\r\n'
            vcal += 'X-EPOCAGENDAENTRYTYPE:EVENT\r\n'
            if SETTING['SYNC'] == 0:
                vcal += 'CLASS:CONFIDENTIAL\r\n'
            elif SETTING['SYNC'] == 1:
                vcal += 'CLASS:PRIVATE\r\n'
            elif SETTING['SYNC'] == 2:
                vcal += 'CLASS:PUBLIC\r\n'
            vcal += 'SEQUENCE:0\r\n'
            vcal += 'X-METHOD:NONE\r\n'
            vcal += 'END:VEVENT\r\n'
        vcal += 'END:VCALENDAR'
        
        return vcal
    
    def import_vcal(self, vcal):
        """カレンダーに天気予報情報を登録"""
        import calendar
        try:
            caldb = calendar.open()
            caldb.import_vcalendars(vcal)
        except:
            raise
    
    def tomorrow(self, today):
        year = int(today[:4])
        month = int(today[4:6])
        day = int(today[6:])
        if day == 31 and month == 12:
            year += 1
            month = 1
            day = 1
        elif day == 31 and month in [1, 3, 5, 7, 8, 10]:
            month += 1
            day = 1
        elif day == 30 and month in [4, 6, 9, 11]:
            month += 1
            day = 1
        elif day == 29 and month == 2:
            month += 1
            day = 1
        elif day == 28 and month == 2 and not (year % 4) and \
             (year % 100) or not (year % 400):
            day += 1
        elif day == 28 and month == 2:
            month += 1
            day = 1
        else:
            day += 1
        return '%4d%02d%02d' % (year, month, day)
    
    def quopri(self, f, i):
        """入力文字列をQuoted-Printableにエンコード"""
        if i < 2:
            qp = u'%d=E6=97=A5%s %s=E2=84=83 %s%%' \
                  % (int(f['d'][6:]), str(f['w']), str(f['t']), str(f['p'])) 
        else:
            qp = u'%s %s=E2=84=83 %s%%' \
                  % (str(f['w']), str(f['t']), str(f['p']))
        # 絵文字利用
        if SETTING['PICT']>0 and SETTING['PICT']<4: # PICT =1,2,3 (except 0,4)
            subtable = [(unicode('雪'), u'=EE=81=88'),
                        (unicode('曇'), u'=EE=81=89'),
                        (unicode('晴'), u'=EE=81=8A'),
                        (unicode('雨'), u'=EE=81=8B'),
                        (unicode('雷'), u'=EE=84=BD'),
                        (unicode('暴風'), u'=EE=8C=B0'),
                        (unicode('吹'), u'=EE=8C=B0'),
                        (unicode('〓'), u'=E3=80=93')] 
        # 絵文字不利用
        else:
            subtable = [(unicode('雪'), u'=E9=9B=AA'),
                        (unicode('曇'), u'=E6=9B=87'),
                        (unicode('晴'), u'=E6=99=B4'),
                        (unicode('雨'), u'=E9=9B=A8'),
                        (unicode('雷'), u'=E9=9B=B7'),
                        (unicode('暴風'), u'=E6=9A=B4=E9=A2=A8'),
                        (unicode('吹'), u'=E5=90=B9'),
                        (unicode('〓'), u'=E3=80=93')]
        for s in subtable:
            qp = qp.replace(s[0], s[1])
        return str(qp)
    
    def get_time(self):
        """現在時刻の取得"""
        import time
        year = int(time.strftime('%Y', time.localtime()))
        month = int(time.strftime('%m', time.localtime()))
        day = int(time.strftime('%d', time.localtime()))
        hour = int(time.strftime('%H', time.localtime()))
        minute = int(time.strftime('%M', time.localtime()))
        sec = int(time.strftime('%S', time.localtime()))
        return (year, month, day, hour, minute, sec)

def read_config():
    """設定を読み込む"""
    global APID
    global SETTING
    global Debug_in  #*1
    global Debug_out #*1

    try:
        cfg = ConfigParser.ConfigParser()
        cfg.read(CFG_FILE)
        APID = int(cfg.get('PyStation', 'APID'))
        SETTING['LOCID'] = int(cfg.get('PyStation Weather', 'locid'))
        SETTING['PICT'] = int(cfg.get('PyStation Weather', 'pict'))
        SETTING['SYNC'] = int(cfg.get('PyStation Weather', 'sync'))
        
    except (ConfigParser.NoSectionError, ConfigParser.NoOptionError):
        appuifw.note(unicode('設定をやり直してください。'), 'error', 1)
        return 0
    except:
        raise
    
    return 1

def check_sig():
    """電波状況の確認"""
    import sysinfo
    try:
        sig = sysinfo.signal_bars()
    except:
        return 0
    else:
        if sig:
            return 1
        else:
            return 0

def main():
    """メインの関数"""
    if not read_config():
        return 0
    if 1: #check_sig():
        try:
            Fetcher().fetch()
        except:
            raise


if __name__ == '__main__':
    main()

#    appuifw.app.set_exit()
#    sys.exit()
